﻿using System;
using System.Collections.Generic;
using Was.OrcSearch.EventArgs;
using Was.OrcSearch.Metadata.Interfaces;

namespace Was.OrcSearch.Services.Interfaces
{
    public interface ISearchService
    {
        int IndexedObjectCount { get; }

        event EventHandler<System.EventArgs> Updating;
        event EventHandler<System.EventArgs> Updated;

        event EventHandler<SearchEventArgs> Searching;
        event EventHandler<SearchEventArgs> Searched;

        void AddObjects(IEnumerable<ISearchable> searchables);
        void RemoveObjects(IEnumerable<ISearchable> searchables);
        void ClearAllObjects();

        IEnumerable<ISearchable> Search(string filter, int maxResults = SearchDefaults.DefaultResults);
        IEnumerable<ISearchableMetadata> GetSearchableMetadata();
    }
}